package controller

import fr.louveauAmine.cvApi.dao.CVApiDB
import io.javalin.apibuilder.CrudHandler
import io.javalin.http.Context
import view.DeleteTag
import view.Tag
import view.toEntity
import view.toView

class TagController(val database: CVApiDB) {
    fun create(ctx: Context) {
        database.transaction {
            val bodyAsClass = ctx.bodyAsClass(Tag::class.java)
            database.tagsQueries.insertTag(bodyAsClass.toEntity())
            val executeAsOne =
                database.tagsQueries.oneTag(bodyAsClass.name, bodyAsClass.category).executeAsOne()
            ctx.json(executeAsOne.toView())
        }
    }

    fun delete(ctx: Context) {
        val bodyAsClass = ctx.bodyAsClass(DeleteTag::class.java)
        database.tagsQueries.deleteTag(bodyAsClass.name, bodyAsClass.category)
    }
}
